﻿class AttackPattern
{		
	private var _waypoints:Array;
	private var _speedMultiplier:Number;
	private var _damageMultiplier:Number;
	private var _projectileSpeedMultiplier:Number;
	private var _fireDelayMultiplier:Number;
	private var _healthMultiplier:Number;	
	private var _scaleMultiplier:Number = 1;	
	
	public function initialize()
	{
		_waypoints = new Array();
	}
	
	public function setSpeedMultiplier(value:Number)
	{
		_speedMultiplier = value;
	}
	
	public function setDamageMultiplier(value:Number)
	{
		_damageMultiplier = value;
	}

	public function setFireDelayMultiplier(value:Number)
	{
		_fireDelayMultiplier = value;
	}

	public function setHealthMultiplier(value:Number)
	{
		_healthMultiplier = value;
	}

	public function setProjectileSpeedMultiplier(value:Number)
	{
		_projectileSpeedMultiplier = value;
	}
	
	public function setScaleMultiplier(value:Number)
	{
		_scaleMultiplier = value;
	}
	
	public function getSpeedMultiplier()
	{
		return _speedMultiplier;
	}
	
	public function getDamageMultiplier()
	{
		return _damageMultiplier;
	}

	public function getFireDelayMultiplier()
	{
		return _fireDelayMultiplier;
	}

	public function getHealthMultiplier()
	{
		return _healthMultiplier;
	}

	public function getProjectileSpeedMultiplier()
	{
		return _projectileSpeedMultiplier;
	}

	public function getScaleMultiplier()
	{
		return _scaleMultiplier;
	}

	public function getWaypoint(index:Number, attackPatternDeltaX:Number, attackPatternDeltaY:Number)
	{
		var waypoint:Waypoint = new Waypoint();
		
		waypoint._x = _waypoints[index]._x + attackPatternDeltaX;
		waypoint._y = _waypoints[index]._y + attackPatternDeltaY;
		waypoint._soundTrigger = _waypoints[index]._soundTrigger;

		return waypoint;
	}
	
	public function getWaypointCount()
	{
		return _waypoints.length;
	}
	
	// attack patterns
	
	//
	// Episode 1 Mission 1
	//
	
	public static function createE1M1Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.5;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.75;
		attackPattern._fireDelayMultiplier = 2;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

		attackPattern._waypoints.push(Waypoint.create(-25, -21));
		attackPattern._waypoints.push(Waypoint.create(819, 605));
		
		return attackPattern;
	}	
	
	public static function createE1M1Group2AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.5;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.75;
		attackPattern._fireDelayMultiplier = 2;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

		attackPattern._waypoints.push(Waypoint.create(811, -19));
		attackPattern._waypoints.push(Waypoint.create(-16, 611));
		
		return attackPattern;
	}	
	
	public static function createE1M1Group3AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.5;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.75;
		attackPattern._fireDelayMultiplier = 2;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

		attackPattern._waypoints.push(Waypoint.create(295, -27));
		attackPattern._waypoints.push(Waypoint.create(286, 621));
		
		return attackPattern;
	}	
	
	public static function createE1M1Group4AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.5;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.75;
		attackPattern._fireDelayMultiplier = 2;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

		attackPattern._waypoints.push(Waypoint.create(510, -30));
		attackPattern._waypoints.push(Waypoint.create(510, 620));
		
		return attackPattern;
	}

	
	//
	// Episode 1 Mission 2
	//
	
	public static function createE1M2Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.5;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.75;
		attackPattern._fireDelayMultiplier = 2;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

		attackPattern._waypoints.push(Waypoint.create(27, -13));
		attackPattern._waypoints.push(Waypoint.create(110, 91));
		attackPattern._waypoints.push(Waypoint.create(286, 150));
		attackPattern._waypoints.push(Waypoint.create(497, 156));
		attackPattern._waypoints.push(Waypoint.create(654, 166));
		attackPattern._waypoints.push(Waypoint.create(778, 253));
		attackPattern._waypoints.push(Waypoint.create(851, 316));
		attackPattern._waypoints.push(Waypoint.create(837, 431));
		attackPattern._waypoints.push(Waypoint.create(785, 452));
		attackPattern._waypoints.push(Waypoint.create(643, 475));
		attackPattern._waypoints.push(Waypoint.create(363, 511));
		attackPattern._waypoints.push(Waypoint.create(204, 513));
		attackPattern._waypoints.push(Waypoint.create(32, 520));
		attackPattern._waypoints.push(Waypoint.create(-66, 522));
		
		return attackPattern;
	}	
	
	public static function createE1M2Group2AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.65;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.80;
		attackPattern._fireDelayMultiplier = 1.75;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

		attackPattern._waypoints.push(Waypoint.create(473, -30));
		attackPattern._waypoints.push(Waypoint.create(216, 216));
		attackPattern._waypoints.push(Waypoint.create(638, 327));
		attackPattern._waypoints.push(Waypoint.create(154, 433));
		attackPattern._waypoints.push(Waypoint.create(856, 620));
		
		return attackPattern;
	}	

	//
	// Episode 1 Mission 3
	//
	
	public static function createE1M3Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.75;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.85;
		attackPattern._fireDelayMultiplier = 1.5;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(30, -26));
attackPattern._waypoints.push(Waypoint.create(273, 149));
attackPattern._waypoints.push(Waypoint.create(270, 652));
		
		return attackPattern;
	}	
	
	public static function createE1M3Group2AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.75;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.85;
		attackPattern._fireDelayMultiplier = 1.5;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(768, -29));
attackPattern._waypoints.push(Waypoint.create(514, 152));
attackPattern._waypoints.push(Waypoint.create(515, 654));
		
		return attackPattern;
	}	

	public static function createE1M3Group3AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.75;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.85;
		attackPattern._fireDelayMultiplier = 1.5;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(301, -53));
attackPattern._waypoints.push(Waypoint.create(64, 204));
attackPattern._waypoints.push(Waypoint.create(271, 650));
		
		return attackPattern;
	}	
	
	public static function createE1M3Group4AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.75;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.85;
		attackPattern._fireDelayMultiplier = 1.5;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(566, -54));
attackPattern._waypoints.push(Waypoint.create(724, 203));
attackPattern._waypoints.push(Waypoint.create(509, 647));
		
		return attackPattern;
	}	
		
	//
	// Episode 1 Mission 4
	//
	
	public static function createE1M4Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.85;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.95;
		attackPattern._fireDelayMultiplier = 1.25;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(400, -100));
attackPattern._waypoints.push(Waypoint.create(400, 700));
		
		return attackPattern;
	}	
	
	public static function createE1M4Group2AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.85;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.95;
		attackPattern._fireDelayMultiplier = 1.25;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(146, -55));
attackPattern._waypoints.push(Waypoint.create(173, 174));
attackPattern._waypoints.push(Waypoint.create(798, 596));
		
		return attackPattern;
	}	

	public static function createE1M4Group3AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.85;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.95;
		attackPattern._fireDelayMultiplier = 1.25;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(640, -58));
attackPattern._waypoints.push(Waypoint.create(517, 188));
attackPattern._waypoints.push(Waypoint.create(-42, 626));;
		
		return attackPattern;
	}	

	//
	// Episode 1 Mission 5
	//
	
	public static function createE1M5Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.75;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 0.65;
		attackPattern._fireDelayMultiplier = 1.25;
		attackPattern._healthMultiplier = 0.85;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(400, -100));
attackPattern._waypoints.push(Waypoint.create(400, 700));
		
		return attackPattern;
	}	
	
	//
	// Episode 1 Mission 6
	//
	
	public static function createE1M6Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(400, -100));
attackPattern._waypoints.push(Waypoint.create(400, 700));
		
		return attackPattern;
	}	
		
	public static function createE1M6Group2AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(15, 642));
attackPattern._waypoints.push(Waypoint.create(33, 194));
attackPattern._waypoints.push(Waypoint.create(852, -26));
		
		return attackPattern;
	}	
			
	public static function createE1M6Group3AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(784, 640));
attackPattern._waypoints.push(Waypoint.create(741, 189));
attackPattern._waypoints.push(Waypoint.create(-38, -39));
		
		return attackPattern;
	}	

	//
	// Episode 1 Mission 7
	//
	
	public static function createE1M7Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(150, -50));
attackPattern._waypoints.push(Waypoint.create(-50, 650));

		return attackPattern;
	}		
	public static function createE1M7Group2AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(250, -50));
attackPattern._waypoints.push(Waypoint.create(150, 650));
		
		return attackPattern;
	}		
	public static function createE1M7Group3AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(350, -50));
attackPattern._waypoints.push(Waypoint.create(350, 650));
		
		return attackPattern;
	}		
	public static function createE1M7Group4AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(450, -50));
attackPattern._waypoints.push(Waypoint.create(600, 650));
		
		return attackPattern;
	}		
	public static function createE1M7Group5AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(550, -50));
attackPattern._waypoints.push(Waypoint.create(850, 650));
		
		return attackPattern;
	}		
	public static function createE1M7Group6AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(-100, 250));
attackPattern._waypoints.push(Waypoint.create(900, 250));
		
		return attackPattern;
	}		
	public static function createE1M7Group7AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(900, 200));
attackPattern._waypoints.push(Waypoint.create(-100, 200));
		
		return attackPattern;
	}		
	public static function createE1M7Group8AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(-100, 150));
attackPattern._waypoints.push(Waypoint.create(900, 150));
		
		return attackPattern;
	}		
	public static function createE1M7Group9AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(900, 100));
attackPattern._waypoints.push(Waypoint.create(-100, 100));
		
		return attackPattern;
	}
	
	//
	// Episode 1 Mission 8
	//
	
	public static function createE1M8Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(89, -25));
attackPattern._waypoints.push(Waypoint.create(73, 75));
attackPattern._waypoints.push(Waypoint.create(-50, 156));

		return attackPattern;
	}		
	public static function createE1M8Group2AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(748, -29));
attackPattern._waypoints.push(Waypoint.create(745, 81));
attackPattern._waypoints.push(Waypoint.create(873, 204));
		
		return attackPattern;
	}		
	public static function createE1M8Group3AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(244, -31));
attackPattern._waypoints.push(Waypoint.create(247, 107));
attackPattern._waypoints.push(Waypoint.create(314, 137));
attackPattern._waypoints.push(Waypoint.create(408, 145));
attackPattern._waypoints.push(Waypoint.create(488, 143));
attackPattern._waypoints.push(Waypoint.create(550, 88));
attackPattern._waypoints.push(Waypoint.create(567, 23));
attackPattern._waypoints.push(Waypoint.create(568, -60));
attackPattern._waypoints.push(Waypoint.create(571, -120));
		
		return attackPattern;
	}		
	public static function createE1M8Group4AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(377, -31));
attackPattern._waypoints.push(Waypoint.create(369, 17));
attackPattern._waypoints.push(Waypoint.create(368, 78));
attackPattern._waypoints.push(Waypoint.create(361, 150));
attackPattern._waypoints.push(Waypoint.create(416, 186));
attackPattern._waypoints.push(Waypoint.create(472, 176));
attackPattern._waypoints.push(Waypoint.create(477, 84));
attackPattern._waypoints.push(Waypoint.create(478, 29));
attackPattern._waypoints.push(Waypoint.create(478, -20));
attackPattern._waypoints.push(Waypoint.create(475, -83));
		
		return attackPattern;
	}		
	public static function createE1M8Group5AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(551, -26));
attackPattern._waypoints.push(Waypoint.create(549, 33));
attackPattern._waypoints.push(Waypoint.create(532, 93));
attackPattern._waypoints.push(Waypoint.create(504, 132));
attackPattern._waypoints.push(Waypoint.create(444, 166));
attackPattern._waypoints.push(Waypoint.create(381, 162));
attackPattern._waypoints.push(Waypoint.create(289, 157));
attackPattern._waypoints.push(Waypoint.create(213, 137));
attackPattern._waypoints.push(Waypoint.create(192, 98));
attackPattern._waypoints.push(Waypoint.create(190, 44));
attackPattern._waypoints.push(Waypoint.create(191, 5));
attackPattern._waypoints.push(Waypoint.create(191, -63));
		
		return attackPattern;
	}		
	
	//
	// Episode 1 Mission 9
	//
	
	public static function createE1M9Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(-20, -62));
attackPattern._waypoints.push(Waypoint.create(110, 107));
attackPattern._waypoints.push(Waypoint.create(-97, 218));
attackPattern._waypoints.push(Waypoint.create(112, 306));
attackPattern._waypoints.push(Waypoint.create(-104, 437));
attackPattern._waypoints.push(Waypoint.create(115, 485));
attackPattern._waypoints.push(Waypoint.create(195, 559));
attackPattern._waypoints.push(Waypoint.create(310, 573));
attackPattern._waypoints.push(Waypoint.create(437, 578));
attackPattern._waypoints.push(Waypoint.create(553, 578));
attackPattern._waypoints.push(Waypoint.create(593, 539));
attackPattern._waypoints.push(Waypoint.create(662, 481));
attackPattern._waypoints.push(Waypoint.create(721, 469));
attackPattern._waypoints.push(Waypoint.create(828, 467));

		return attackPattern;
	}		
	public static function createE1M9Group2AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();


attackPattern._waypoints.push(Waypoint.create(847, -68));
attackPattern._waypoints.push(Waypoint.create(676, 94));
attackPattern._waypoints.push(Waypoint.create(924, 204));
attackPattern._waypoints.push(Waypoint.create(714, 306));
attackPattern._waypoints.push(Waypoint.create(919, 407));
attackPattern._waypoints.push(Waypoint.create(725, 454));
attackPattern._waypoints.push(Waypoint.create(670, 482));
attackPattern._waypoints.push(Waypoint.create(602, 531));
attackPattern._waypoints.push(Waypoint.create(567, 579));
attackPattern._waypoints.push(Waypoint.create(502, 586));
attackPattern._waypoints.push(Waypoint.create(438, 580));
attackPattern._waypoints.push(Waypoint.create(312, 576));
attackPattern._waypoints.push(Waypoint.create(198, 562));
attackPattern._waypoints.push(Waypoint.create(103, 495));
attackPattern._waypoints.push(Waypoint.create(-98, 434));
		
		return attackPattern;
	}		
	public static function createE1M9Group3AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 0.50;
		attackPattern._damageMultiplier = 1.25;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 10;
		attackPattern._scaleMultiplier = 5;
		
		attackPattern._waypoints = new Array();

attackPattern._waypoints.push(Waypoint.create(400, -250));
attackPattern._waypoints.push(Waypoint.create(400, 850));
		
		return attackPattern;
	}		
	
	//
	// Episode 1 Mission 10
	//
	
	public static function createE1M10Group1AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();
		
attackPattern._waypoints.push(Waypoint.create(27, -49));
attackPattern._waypoints.push(Waypoint.create(16, 654));

		return attackPattern;
	}		
		
	public static function createE1M10Group2AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();
		
		attackPattern._waypoints.push(Waypoint.create(105, -45));
		attackPattern._waypoints.push(Waypoint.create(79, 655));

		return attackPattern;
	}		
		
	public static function createE1M10Group3AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();
		
attackPattern._waypoints.push(Waypoint.create(181, -44));
attackPattern._waypoints.push(Waypoint.create(866, 647));

		return attackPattern;
	}		
		
	public static function createE1M10Group4AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();
		
attackPattern._waypoints.push(Waypoint.create(767, -25));
attackPattern._waypoints.push(Waypoint.create(779, 633));

		return attackPattern;
	}		
		
	public static function createE1M10Group5AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();
		

attackPattern._waypoints.push(Waypoint.create(705, -22));
attackPattern._waypoints.push(Waypoint.create(697, 640));

		return attackPattern;
	}		
		
	public static function createE1M10Group6AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();
		
attackPattern._waypoints.push(Waypoint.create(628, -31));
attackPattern._waypoints.push(Waypoint.create(-54, 632));

		return attackPattern;
	}		
		
	public static function createE1M10Group7AttackPattern()
	{	
		var attackPattern:AttackPattern = new AttackPattern();
		
		attackPattern._speedMultiplier = 1;
		attackPattern._damageMultiplier = 1;
		attackPattern._projectileSpeedMultiplier = 1;
		attackPattern._fireDelayMultiplier = 1;
		attackPattern._healthMultiplier = 1;
		
		attackPattern._waypoints = new Array();
		
attackPattern._waypoints.push(Waypoint.create(384, -82));
attackPattern._waypoints.push(Waypoint.create(475, -51));
attackPattern._waypoints.push(Waypoint.create(582, -6));
attackPattern._waypoints.push(Waypoint.create(648, 28));
attackPattern._waypoints.push(Waypoint.create(707, 50));
attackPattern._waypoints.push(Waypoint.create(771, 70));
attackPattern._waypoints.push(Waypoint.create(706, 115));
attackPattern._waypoints.push(Waypoint.create(655, 122));
attackPattern._waypoints.push(Waypoint.create(580, 148));
attackPattern._waypoints.push(Waypoint.create(483, 183));
attackPattern._waypoints.push(Waypoint.create(392, 208));
attackPattern._waypoints.push(Waypoint.create(313, 184));
attackPattern._waypoints.push(Waypoint.create(257, 163));
attackPattern._waypoints.push(Waypoint.create(186, 139));
attackPattern._waypoints.push(Waypoint.create(110, 119));
attackPattern._waypoints.push(Waypoint.create(29, 91));
attackPattern._waypoints.push(Waypoint.create(78, 33));
attackPattern._waypoints.push(Waypoint.create(140, 2));
attackPattern._waypoints.push(Waypoint.create(228, -30));
attackPattern._waypoints.push(Waypoint.create(299, -69));

		return attackPattern;
	}		
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	// attack formations 
	public static function spawnStarDestroyerClassicFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   StarDestroyerEnemyShip.spawn(
														 0,
														 0,
														 attackPattern));
	}
	
	public static function spawnTieFigherSingleFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 0,
														 0,
														 attackPattern));
	}
	
	public static function spawnTieFigherCoupleFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -35,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 35,
														 0,
														 attackPattern));
	}	
	public static function spawnTieInterceptorCoupleFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -35,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 35,
														 0,
														 attackPattern));
	}		
	public static function spawnTieFigherTripleFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 0,
														 15,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -35,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 35,
														 0,
														 attackPattern));
	}
	
	public static function spawnTieFigherDiamondFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 0,
														 -35,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 0,
														 35,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -35,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 35,
														 0,
														 attackPattern));
	}
	
	public static function spawnTieFigherBomberHalfCircleFormation(attackPattern:AttackPattern)
	{
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -75,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 75,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -35,
														 35,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 35,
														 35,
														 attackPattern));		
		GameState.addEnemyShip(
							   TieBomberEnemyShip.spawn(
														 0,
														 0,
														 attackPattern));				
	}
	
	public static function spawnTieFigherBomberCircleFormation(attackPattern:AttackPattern)
	{
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -75,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 75,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 0,
														 -75,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 0,
														 75,
														 attackPattern));		
		GameState.addEnemyShip(
							   TieBomberEnemyShip.spawn(
														 0,
														 0,
														 attackPattern));				
	}
	
	public static function spawnTieFigherBomberFullScreenFormation(attackPattern:AttackPattern)
	{
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 0,
														 175,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -200,
														 150,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -300,
														 150,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -350,
														 75,
														 attackPattern));		
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 200,
														 150,
														 attackPattern));		
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 300,
														 150,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 350,
														 75,
														 attackPattern));		
		GameState.addEnemyShip(
							   TieBomberEnemyShip.spawn(
														 -200,
														 0,
														 attackPattern));				
		GameState.addEnemyShip(
							   TieBomberEnemyShip.spawn(
														 200,
														 0,
														 attackPattern));				
	}
	
	public static function spawnTieFigherBomberInterceptorFullScreenFormation(attackPattern:AttackPattern)
	{
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 0,
														 175,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -200,
														 150,
														 attackPattern));
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 -300,
														 150,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -350,
														 75,
														 attackPattern));		
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 200,
														 150,
														 attackPattern));		
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 300,
														 150,
														 attackPattern));
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 350,
														 75,
														 attackPattern));		
		GameState.addEnemyShip(
							   TieBomberEnemyShip.spawn(
														 -200,
														 0,
														 attackPattern));				
		GameState.addEnemyShip(
							   TieBomberEnemyShip.spawn(
														 200,
														 0,
														 attackPattern));				
	}
	
	public static function spawnTieBomberSingleFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieBomberEnemyShip.spawn(
														 0,
														 0,
														 attackPattern));
	}
	
	public static function spawnTieInterceptorSingleFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 0,
														 0,
														 attackPattern));
	}
	
	public static function spawnStarDestroyerSingleFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   StarDestroyerEnemyShip.spawn(
														 0,
														 0,
														 attackPattern));
	}
	
	public static function spawnTieInterceptorDiamondFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 0,
														 -35,
														 attackPattern));
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 0,
														 35,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -35,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 35,
														 0,
														 attackPattern));
	}
	
	public static function spawnTieFighterDiamondFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 0,
														 -35,
														 attackPattern));
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 0,
														 35,
														 attackPattern));
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 -35,
														 0,
														 attackPattern));
		GameState.addEnemyShip(
							   TieInterceptorEnemyShip.spawn(
														 35,
														 0,
														 attackPattern));
	}
	
	public static function spawnTieFighterWaveFormation(attackPattern:AttackPattern)
	{		
		GameState.addEnemyShip(
							   TieBomberEnemyShip.spawn(
														 0,
														 -50,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -150,
														 50,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 -75,
														 65,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 0,
														 75,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 75,
														 50,
														 attackPattern));
		GameState.addEnemyShip(
							   TieFighterEnemyShip.spawn(
														 150,
														 65,
														 attackPattern));
	}
	
}