﻿class EnemyShip extends Ship
{		
	private var _attackPattern:AttackPattern;
	private var _attackPatternWaypointIndex:Number = 0;
	private var _requiresOrientation:Boolean = true;
	private var _attackPatternDeltaX:Number = 0;
	private var _attackPatternDeltaY:Number = 0;
	private var _flyBySound:Sound;
	
	public function getAttackPattern()
	{
		return _attackPattern;
	}
	
	public function canAttack()
	{		
		if (_x > 0 && _x < 800 && _y > 0 && _y < 600 && GameState.getPlayer().getShip() != null)
			return (_lastFireTime + _fireDelay + random(_fireDelay)) < GameState.getFrameTime();
		else
			return false;
	}
	
	public function think()
	{							
		if (GameState.checkPlayerCollision(this))
		{			
			if (GameState.getPlayer().getShip().getHealth() >= _health)
			{
				GameState.getPlayer().getShip().damage(_health);
				damage(_health);			
			}
			else
			{
				GameState.getPlayer().getShip().damage(_health);
			}
		}
		
		if (_attackPattern != null &&
			_attackPatternWaypointIndex < _attackPattern.getWaypointCount())
		{
			var waypoint:Waypoint = _attackPattern.getWaypoint(_attackPatternWaypointIndex, _attackPatternDeltaX, _attackPatternDeltaY);

			if (_attackPatternWaypointIndex == 0)
			{
				_x = waypoint.getX();
				_y = waypoint.getY();				

				waypoint = _attackPattern.getWaypoint(_attackPatternWaypointIndex);				
			}
			
				_rotation = ((Math.atan2(
				   waypoint.getY() - _y,
				   waypoint.getX() - _x) / Math.PI) * 180);					

				
			var oldX:Number = _x;
			var oldY:Number = _y;
						
			move();
			
			if ((oldX <= 0 || oldX >= 800 || oldY <= 0 || oldY >= 600) &&
																	  _x > 0 && _x < 800 && _y > 0 && _y < 600 && _flyBySound != null && 
																	  GameState.getLastFlyByTime() + 1000 < GameState.getFrameTime()
																	  && GameState.getPlayer().getShip() != null)			
			{
				GameState.setLastFlyByTime(GameState.getFrameTime());
				SoundBoard.playSound(_flyBySound);
			}
			
			if (distanceTo(
						   oldX,
						   oldY,
						   waypoint.getX(),
						   waypoint.getY()) <=
				distanceTo(
						   oldX,
						   oldY,
						   _x,
						   _y))
			{								
				//trace("Waypoint reached" + _attackPatternWaypointIndex);
				
				if (waypoint._soundTrigger != null)
				{
					//SoundBoard.playSound(waypoint._soundTrigger);
				}
					
				// reached waypoint								
				_x = waypoint.getX();
				_y = waypoint.getY();
				
				_attackPatternWaypointIndex ++;				
				
				waypoint = _attackPattern.getWaypoint(_attackPatternWaypointIndex, _attackPatternDeltaX, _attackPatternDeltaY);
					
				_rotation = ((Math.atan2(
				   waypoint.getY() - _y,
				   waypoint.getX() - _x) / Math.PI) * 180);									
			}
		}		
		else if (_attackPatternWaypointIndex >= _attackPattern.getWaypointCount())
		{
			_attackPatternWaypointIndex = 0;
		}
		
		// attack whenever we can
		attack();
	}
	
	private function distanceTo(x1:Number, y1:Number, x2:Number, y2:Number)
	{
		return Math.sqrt(((x1 - x2) * (x1 - x2)) + ((y1 - y2) * (y1 - y2)));
	}
}