﻿class StarDestroyerEnemyShip extends EnemyShip
{
	private var _attack2FireDelay:Number = 775;
	private var _attack3FireDelay:Number = 800;
	private var _attack4FireDelay:Number = 900;
	private var _attack5FireDelay:Number = 850;
	private var _attack6FireDelay:Number = 1550;
	private var _attack7FireDelay:Number = 1550;
	private var _attack8FireDelay:Number = 3500;
	
	private var _lastFireTime2:Number = 0;
	private var _lastFireTime3:Number = 0;
	private var _lastFireTime4:Number = 0;
	private var _lastFireTime5:Number = 0;
	private var _lastFireTime6:Number = 0;
	private var _lastFireTime7:Number = 0;
	private var _lastFireTime8:Number = 0;

	
	static function spawn(
							   deltaX:Number,
							   deltaY:Number,
							   attackPattern:AttackPattern)
	{
		trace("Creating star destroyer ship");
		
		var index:Number = GameState.getNextEnemyShipId();
		var shipIdentifier:String = "StarDestroyerEnemy" + index;		
		
		var ship:MovieClip = _root.attachMovie(
			"StarDestroyer",
			shipIdentifier,
			GameState.getShipDepth() + index);						  
		
		ship._attackPatternDeltaX = deltaX;
		ship._attackPatternDeltaY = deltaY;		
		ship._height *= (GameState.getActiveScale() * attackPattern.getScaleMultiplier());
		ship._width *= (GameState.getActiveScale() * attackPattern.getScaleMultiplier());
		ship._isPlayer = false;
		ship._health = 1750 * attackPattern.getHealthMultiplier();		
		ship._speed = 3 * attackPattern.getSpeedMultiplier();		
		ship._fireDelay = 650 * attackPattern.getFireDelayMultiplier();		
		ship._attack2FireDelay *= attackPattern.getFireDelayMultiplier();		
		ship._attack3FireDelay *= attackPattern.getFireDelayMultiplier();		
		ship._attack4FireDelay *= attackPattern.getFireDelayMultiplier();		
		ship._attack5FireDelay *= attackPattern.getFireDelayMultiplier();		
		ship._attack6FireDelay *= attackPattern.getFireDelayMultiplier();		
		ship._attack7FireDelay *= attackPattern.getFireDelayMultiplier();		
		ship._attack8FireDelay *= attackPattern.getFireDelayMultiplier();		
		ship._attackDamage = 5 * attackPattern.getDamageMultiplier();
		ship._attackPattern = attackPattern;		
		
		return ship;
	}	
	
	private function canAttack1()
	{
		return (_lastFireTime + _fireDelay + random(_fireDelay)) < GameState.getFrameTime() && GameState.getPlayer().getShip() != null;
	}
	private function canAttack2()
	{
		return (_lastFireTime2 + _attack2FireDelay + random(_attack2FireDelay)) < GameState.getFrameTime() && GameState.getPlayer().getShip() != null;
	}
	private function canAttack3()
	{
		return (_lastFireTime3 + _attack3FireDelay + random(_attack3FireDelay)) < GameState.getFrameTime() && GameState.getPlayer().getShip() != null;
	}
	private function canAttack4()
	{
		return (_lastFireTime4 + _attack4FireDelay + random(_attack4FireDelay)) < GameState.getFrameTime() && GameState.getPlayer().getShip() != null;
	}
	private function canAttack5()
	{
		return (_lastFireTime5 + _attack5FireDelay + random(_attack5FireDelay)) < GameState.getFrameTime() && GameState.getPlayer().getShip() != null;
	}
	private function canAttack6()
	{
		return (_lastFireTime6 + _attack6FireDelay + random(_attack6FireDelay)) < GameState.getFrameTime() && GameState.getPlayer().getShip() != null;
	}
	private function canAttack7()
	{
		return (_lastFireTime7 + _attack7FireDelay + random(_attack7FireDelay)) < GameState.getFrameTime() && GameState.getPlayer().getShip() != null;
	}
	private function canAttack8()
	{
		return false;//(_lastFireTime8 + _attack8FireDelay + random(_attack8FireDelay)) < GameState.getFrameTime();
	}
	
	public function attack()
	{		
		if (canAttack1())
		{
			GameState.addProjectile(
									Projectile.spawnIonCannon(
															this,
															_x,
															_y + (_height / 2),
															(90 / Math.PI) * 180,
															1.5));		
			_lastFireTime = GameState.getFrameTime();			
		}				
		if (canAttack2())
		{
			GameState.addProjectile(
									Projectile.spawnIonCannon(
															this,
															_x + (_width / 4),
															_y + (_height / 2),
															(90 / Math.PI) * 180,
															1.5));		
			_lastFireTime2 = GameState.getFrameTime();			
		}		
		if (canAttack3())
		{
			GameState.addProjectile(
									Projectile.spawnIonCannon(
															this,
															_x - (_width / 4),
															_y + (_height / 2),
															(90 / Math.PI) * 180,
															1.5));		
			_lastFireTime3 = GameState.getFrameTime();			
		}		
		if (canAttack4())
		{
			GameState.addProjectile(
									Projectile.spawnIonCannon(
															this,
															_x + (_width / 2),
															_y + (_height / 4),
															(90 / Math.PI) * 180,
															1.5));		
			_lastFireTime4 = GameState.getFrameTime();			
		}		
		if (canAttack5())
		{
			GameState.addProjectile(
									Projectile.spawnIonCannon(
															this,
															_x - (_width / 2),
															_y + (_height / 4),
															(
															 90 / Math.PI) * 180,
															1.5));		
			_lastFireTime5 = GameState.getFrameTime();			
		}		
		if (canAttack6())
		{
			GameState.addProjectile(
									Projectile.spawnTurboLaser(
															this,
															_x - (_width / 3),
															_y - (_height / 4),
															((Math.atan2(
																	   GameState.getPlayer().getShip()._y - _y,
																		GameState.getPlayer().getShip()._x - _x) / Math.PI) * 180),																	   
															2.5));		
			_lastFireTime6 = GameState.getFrameTime();			
		}		
		if (canAttack7())
		{
			GameState.addProjectile(
									Projectile.spawnTurboLaser(
															this,
															_x + (_width / 3),
															_y - (_height / 4),
															((Math.atan2(
																	   GameState.getPlayer().getShip()._y - _y,
																		GameState.getPlayer().getShip()._x - _x) / Math.PI) * 180),																	   
															2.5));		
			_lastFireTime7 = GameState.getFrameTime();			
		}		
		if (canAttack8())
		{
			GameState.addProjectile(
									Projectile.spawnPhotonTorpedo(
															this,
															_x,
															_y,
															((Math.atan2(
																	   GameState.getPlayer().getShip()._y - _y,
																		GameState.getPlayer().getShip()._x - _x) / Math.PI) * 180),																	  
															1.25));		
			_lastFireTime8 = GameState.getFrameTime();			
		}		
	}
}