﻿class TieBomberEnemyShip extends EnemyShip
{
	static function spawn(
							   deltaX:Number,
							   deltaY:Number,
							   attackPattern:AttackPattern)
	{
		trace("Creating tie Bomber ship");
		
		var index:Number = GameState.getNextEnemyShipId();
		var shipIdentifier:String = "TieBomberEnemy" + index;		
		
		var ship:MovieClip = _root.attachMovie(
			"TieBomber",
			shipIdentifier,
			GameState.getShipDepth() + index);						  
						
		ship._attackPatternDeltaX = deltaX;
		ship._attackPatternDeltaY = deltaY;		
		ship._height *= (GameState.getActiveScale() * attackPattern.getScaleMultiplier());
		ship._width *= (GameState.getActiveScale() * attackPattern.getScaleMultiplier());
		ship._isPlayer = false;
		ship._health = 50 * attackPattern.getHealthMultiplier();		
		ship._speed = 8 * attackPattern.getSpeedMultiplier();		
		ship._fireDelay = 650 * attackPattern.getFireDelayMultiplier();		
		ship._attackDamage = 5 * attackPattern.getDamageMultiplier();
		ship._attackPattern = attackPattern;		
		ship._flyBySound = SoundBoard.SOUND_SHIP_TIE_FLYBY;
		
		return ship;
	}	
	
	public function attack()
	{		
		if (!canAttack())
			return;

		GameState.addProjectile(
								Projectile.spawnTurboLaser(
														this,
														_x - (_width / 2),
														_y,
														((Math.atan2(
																	   GameState.getPlayer().getShip()._y - _y,
																		GameState.getPlayer().getShip()._x - _x) / Math.PI) * 180),
														1));		
		
		GameState.addProjectile(
								Projectile.spawnTurboLaser(
														this,
														_x + (_width / 2),
														_y,
														((Math.atan2(
																	   GameState.getPlayer().getShip()._y - _y,
																		GameState.getPlayer().getShip()._x - _x) / Math.PI) * 180),
														1));				
		_lastFireTime = GameState.getFrameTime();
	}
}