﻿class TieInterceptorEnemyShip extends EnemyShip
{
	private var _attack2FireDelay:Number = 1000;
	
	private var _lastFireTime2:Number = 0;
		
	static function spawn(
							   deltaX:Number,
							   deltaY:Number,
							   attackPattern:AttackPattern)
	{
		trace("Creating tie interceptor ship");
		
		var index:Number = GameState.getNextEnemyShipId();
		var shipIdentifier:String = "TieInterceptorEnemy" + index;		
		
		var ship:MovieClip = _root.attachMovie(
			"TieInterceptor",
			shipIdentifier,
			GameState.getShipDepth() + index);						  
		
		ship._attackPatternDeltaX = deltaX;
		ship._attackPatternDeltaY = deltaY;		
		ship._height *= (GameState.getActiveScale() * attackPattern.getScaleMultiplier());
		ship._width *= (GameState.getActiveScale() * attackPattern.getScaleMultiplier());
		ship._isPlayer = false;
		ship._health = 75 * attackPattern.getHealthMultiplier();		
		ship._speed = 13 * attackPattern.getSpeedMultiplier();		
		ship._fireDelay = 650 * attackPattern.getFireDelayMultiplier();		
		ship._attack2FireDelay *= attackPattern.getFireDelayMultiplier();		
		ship._attackDamage = 5 * attackPattern.getDamageMultiplier();
		ship._attackPattern = attackPattern;		
		ship._flyBySound = SoundBoard.SOUND_SHIP_TIE_FLYBY;
		
		return ship;
	}	
	private function canAttack1()
	{
		return (_lastFireTime + _fireDelay + random(_fireDelay)) < GameState.getFrameTime() && GameState.getPlayer().getShip() != null;
	}
	private function canAttack2()
	{
		return (_lastFireTime2 + _attack2FireDelay + random(_attack2FireDelay)) < GameState.getFrameTime() && GameState.getPlayer().getShip() != null;
	}
	
	public function attack()
	{		
		if (canAttack1())
		{
			GameState.addProjectile(
									Projectile.spawnIonCannon(
															this,
															_x - (_width / 2),
															_y,
															_rotation,
															1));		
			
			GameState.addProjectile(
									Projectile.spawnIonCannon(
															this,
															_x + (_width / 2),
															_y,
															_rotation,
															1));				
			_lastFireTime = GameState.getFrameTime();			
		}				
		if (canAttack2())
		{
			GameState.addProjectile(
									Projectile.spawnTurboLaser(
															this,
															_x + (_width / 2),
															_y,
															((Math.atan2(
																		   GameState.getPlayer().getShip()._y - _y,
																			GameState.getPlayer().getShip()._x - _x) / Math.PI) * 180),
															1));				
			_lastFireTime2 = GameState.getFrameTime();			
		}		
	}
}